//Ein kleines Beispiel fr die Anwendung von Steganographie mit der LSB-Methode
//Autor: Markus Lange-Hegermann
//Email: MarkusLH@gmx.de, MarkusLH@web.de
//Instant Messages: Markuslh83@hotmail.com, 116891458, 92239400, LangeHeg
//Fr Updates (eher selten): www.Delphi-Treff.de
//Dieses Programm ist Opensource: In meinem verstndnis bedeutet dies, dass
//Freewareprogramme beliebig aus diesem Programm abschreiben knnen (sollte ich
//erwhnt werden) und es weiterentwickeln drfen. Aber jegliche komerzielle
//Nutzung der Quelltexte und seiner Weiterentwicklung ist ohne meine
//audrckliche Erlaubnis Strafbar.

//Beinhaltet den Quelltext zum Codieren und Decodieren
unit UCodiere;

interface

uses Windows, SysUtils, Classes, Consts, Graphics, UBits, UStatus, Forms;

procedure Codiere(aBitmap: TBitmap; Text: string);
function DeCodiere(aBitmap: TBitmap): string;
function XOrCode(Value: string):string;

implementation

procedure Codiere(aBitmap: TBitmap; Text: string);
var
  i:Integer;
  Pixel: TPoint;
  aChar: Char;
  FarbCode: Byte;
  Farbe: TColor;
begin
  //Grundsztliche Bedingungen prfen
  if (not aBitmap.empty) and (length(Text)>0) then begin
    //Statusanzeige initialisieren
    Application.CreateForm(TStatusForm, StatusForm);
    try
      //Statusanzeige initialisieren
      StatusForm.Start(length(Text));
      //Jedes einzelne Textzeichen codieren
      for i:=1 to length(Text) do begin
        //Zu codierendes Zeichen aus dem Text holen
        aChar:=Text[i];
        //x-, y-Koordinaten des ersten Farbpixels ermitteln
        Pixel:=GetPixel(aBitmap.Width,i*3-2);
        //erste der 3 Farbepixel, in der aChar codiert wird, zwischenspeichern
        Farbe:=aBitmap.Canvas.Pixels[Pixel.x,Pixel.y];
          //Codieren

          //erstes Bit des Zeichens speichern.
          //Farcode ist das zu verndernde Byte aus der Farbe.
          //Aus jeder Farbe lassen sich 3 Farbbytes gewinnen.
          FarbCode:=GetBlue(Farbe);
          //Das letzte Bit aus dem Farbcode wird auf "0" gesetzt
          Farbcode:=Entferne(Farbcode,8);
          //Falls das zu codierende Zeichen an der ersten Stelle "1" hat
          If Erhalte(byte(aChar),1)
            //Dann wird im Farbcode das letzte Bit gesetzt,
            //ansonsten bleibt es auf "0" stehen
            then Farbcode:=Setze(FarbCode,8);
          //Zum Schluss wird die gesammtfarbe wieder zusammengesetzt
          Farbe:=rgb(FarbCode, GetGreen(Farbe), GetRed(Farbe));

          //1. Pixel, 2. Farbbyte, 2. Bit des Zeichens
          FarbCode:=GetGreen(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),2)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(GetBlue(Farbe), FarbCode, GetRed(Farbe));

          //1. Pixel, 3. Farbbyte, 3. Bit des Zeichens
          FarbCode:=GetRed(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),3)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(GetBlue(Farbe), GetGreen(Farbe), FarbCode);

        //Farbe wieder zurch in Bitmap schreiben
        aBitmap.Canvas.Pixels[Pixel.x,Pixel.y]:=Farbe;
                           
        //Nchstes (2.) Farbpixel
        Pixel:=GetPixel(aBitmap.Width,i*3-1);
        Farbe:=aBitmap.Canvas.Pixels[Pixel.x,Pixel.y];

          //2. Pixel, 1. Farbbyte, 4. Bit des Zeichens
          FarbCode:=GetBLue(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),4)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(FarbCode, GetGreen(Farbe), GetRed(Farbe));

          //2. Pixel, 2. Farbbyte, 5. Bit des Zeichens
          FarbCode:=GetGreen(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),5)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(GetBlue(Farbe), FarbCode, GetRed(Farbe));

          //2. Pixel, 3. Farbbyte, 6. Bit des Zeichens
          FarbCode:=GetRed(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),6)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(GetBlue(Farbe), GetGreen(Farbe), FarbCode);

        //Farbe wieder zurch in Bitmap schreiben
        aBitmap.Canvas.Pixels[Pixel.x,Pixel.y]:=Farbe;

        //Nchstes (3. und letztes) Farbpixel
        Pixel:=GetPixel(aBitmap.Width,i*3);
        Farbe:=aBitmap.Canvas.Pixels[Pixel.x,Pixel.y];

          //2. Pixel, 1. Farbbyte, 7. Bit des Zeichens
          FarbCode:=GetBlue(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),7)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(FarbCode, GetGreen(Farbe), GetRed(Farbe));

          //3. Pixel, 2. Farbbyte, 8. Bit des Zeichens
          FarbCode:=GetGreen(Farbe);
          Farbcode:=Entferne(Farbcode,8);
          If Erhalte(byte(aChar),8)
            then Farbcode:=Setze(FarbCode,8);
          Farbe:=rgb(GetBlue(Farbe), FarbCode, GetRed(Farbe));

        //Farbe wieder zurch in Bitmap schreiben
        aBitmap.Canvas.Pixels[Pixel.x,Pixel.y]:=Farbe;

        //Bei jedem Schleifendurchlauf:
        //die Statusanzeige fortsetzen
        StatusForm.Progress;
        //Benutzereingaben zulassen
        Application.ProcessMessages;
        //auf Abbrechen im Statusformular reagieren
        if StatusForm.Abort then break;
      end;
    finally
      StatusForm.free;
      Statusform:=nil;
    end;
  end;
end;

function DeCodiere(aBitmap: TBitmap): string;

  //aus 3 Farben wird ein Zeichen erstellt.
  //aus dem letzten Bit des 1. Farbebytes der 1. Farbe -> 1. Bit des Zeichen
  //aus dem letzten Bit des 2. Farbebytes der 1. Farbe -> 2. Bit des Zeichen
  //aus dem letzten Bit des 3. Farbebytes der 1. Farbe -> 3. Bit des Zeichen
  //aus dem letzten Bit des 1. Farbebytes der 2. Farbe -> 4. Bit des Zeichen
  //aus dem letzten Bit des 2. Farbebytes der 2. Farbe -> 5. Bit des Zeichen
  //aus dem letzten Bit des 3. Farbebytes der 2. Farbe -> 6. Bit des Zeichen
  //aus dem letzten Bit des 1. Farbebytes der 3. Farbe -> 7. Bit des Zeichen
  //aus dem letzten Bit des 2. Farbebytes der 3. Farbe -> 8. Bit des Zeichen
  function MakeChar(var Color1,Color2,Color3: TColor):Char;
  var
    bResult: Byte;
  begin
    bResult:=0;

    if Erhalte(GetBlue(Color1),8)
      then bResult:=Setze(bResult,1);
    if Erhalte(GetGreen(Color1),8)
      then bResult:=Setze(bResult,2);
    if Erhalte(GetRed(Color1),8)
      then bResult:=Setze(bResult,3);
    if Erhalte(GetBlue(Color2),8)
      then bResult:=Setze(bResult,4);
    if Erhalte(GetGreen(Color2),8)
      then bResult:=Setze(bResult,5);
    if Erhalte(GetRed(Color2),8)
      then bResult:=Setze(bResult,6);
    if Erhalte(GetBlue(Color3),8)
      then bResult:=Setze(bResult,7);
    if Erhalte(GetGreen(Color3),8)
      then bResult:=Setze(bResult,8);

    Result:=Char(bResult);
  end;

var
  i,j: Integer;
  Color1,Color2,Color3: TColor;
begin
  //Statusformular initialisieren
  Application.Createform(TStatusForm, StatusForm);
  try
    //Statusformular initialisieren
    Statusform.Start(aBitmap.Height);
    //Variablen initialisieren
    color1:=-1;
    color2:=-1;
    color3:=-1;
    result:='';
    //Grundlegende Abfrage
    if aBitmap<>nil then begin
      //Jedes Pixel durchgehen: i->y-Koordinate
      for i:=0 to aBitmap.Height-1
        do begin
          //Jedes Pixel durchgehen: j->x-Koordinate
          for j:=0 to aBitmap.Width-1
          do begin
            //bei -1 ist 1. Farbe noch Frei und kann gesetzt werden
            if color1=-1
              then color1:=aBitmap.Canvas.Pixels[j,i]
              //bei -1 ist 2. Farbe noch Frei und kann gesetzt werden
              else if color2=-1
                then color2:=aBitmap.Canvas.Pixels[j,i]
                //ansonsten waren sowohl erste als auch 2. Farbe schon gesetzt
                else begin
                  //Die fehlende Farbe war die 3.
                  color3:=aBitmap.Canvas.Pixels[j,i];
                  //aus den 3 Farben wird das nchste Zeichen zusammengetzt
                  //und an das bisherige Ergebnis gehngt
                  Result:=result+MakeChar(Color1,Color2,Color3);
                  //Farbe wieder auf "leer" setzen
                  Color1:=-1;
                  Color2:=-1;
                  Color3:=-1;
                end;
          end;

        //Jeden Schleifendurchlauf in uerster Schleife (bei jedem Zeichen):
        //Forschrittsanzeige zulassen weitersetzen
        Statusform.Progress;
        //Benutzereingabe zulassen
        Application.ProcessMessages;
        //auf Abbrechen im Statusformular reagieren
        If Statusform.Abort then Break;
      end;
    end;
  finally
    StatusForm.Free;  
    Statusform:=nil;
  end;
end;

//Eine einfache 512Bit XOr Codierung mit konstantem Key
function XOrCode(Value: string):string;
const
  Key=#255#8#22#51#69#171#81#41#95#108#20#121#18#215#15#75#234#94#198#83#178#216
  +#183#78#41#84#119#63#211#71#123#38#223#73#197#249#126#227#211#5#36#36#128#5
  +#151#2#198#166#197#181#142#52#174#151#244#164#255#62#173#75#21#197#126#225;
var
  i:Integer;
  Char1, Char2: Char;
begin
  Result:='';
  for i:=0 to Length(Value)-1
    do begin
      Char1:=Value[i+1];
      Char2:=Key[i mod Length(Key)+1];
      Result:=Result+Char(Integer(Char1) XOr Integer(Char2));
    end;
end;

end.
