//Ein kleines Beispiel fr die Anwendung von Steganographie mit der LSB-Methode
//Autor: Markus Lange-Hegermann
//Email: MarkusLH@gmx.de, MarkusLH@web.de
//Instant Messages: Markuslh83@hotmail.com, 116891458, 92239400, LangeHeg
//Fr Updates (eher selten): www.Delphi-Treff.de
//Dieses Programm ist Opensource: In meinem verstndnis bedeutet dies, dass
//Freewareprogramme beliebig aus diesem Programm abschreiben knnen (sollte ich
//erwhnt werden) und es weiterentwickeln drfen. Aber jegliche komerzielle
//Nutzung der Quelltexte und seiner Weiterentwicklung ist ohne meine
//audrckliche Erlaubnis Strafbar.

unit uMain;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus;

type
  TMainform = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    gbImg: TGroupBox;
    ImageScroll: TScrollBox;
    imAnzeige: TImage;
    paImgOben: TPanel;
    btImgOpn: TButton;
    btSavImg: TButton;
    paMitte: TPanel;
    btImgTxt: TButton;
    btTxtImg: TButton;
    gbTxt: TGroupBox;
    paTxtOben: TPanel;
    btSavTxt: TButton;
    btOpnTxt: TButton;
    meText: TRichEdit;
    OpenPictureDialog1: TOpenDialog;
    SavePictureDialog1: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblPixel: TLabel;
    lblText: TLabel;
    lblVerfuegbar: TLabel;
    MainMenu1: TMainMenu;
    Beenden1: TMenuItem;
    Datei1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Bildffnen1: TMenuItem;
    BildSpeichern1: TMenuItem;
    Dateiffenen1: TMenuItem;
    Textppeichern1: TMenuItem;
    Codieren1: TMenuItem;
    BildzuText1: TMenuItem;
    TextzuBild1: TMenuItem;
    Hilfe1: TMenuItem;
    Info1: TMenuItem;
    procedure btSavImgClick(Sender: TObject);
    procedure btImgOpnClick(Sender: TObject);
    procedure btOpnTxtClick(Sender: TObject);
    procedure btSavTxtClick(Sender: TObject);
    procedure btImgTxtClick(Sender: TObject);
    procedure btTxtImgClick(Sender: TObject);
    procedure meTextChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Beenden1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
  private
    //Berechnet verfgbare Textzeichen und gibt Anzahl aus
    Procedure Verfuegbar;
    Procedure Enable(Value: Boolean);
  end;

var
  Mainform: TMainform;

implementation

uses UCodiere, UStatus, uBits, UInfo;

{$R *.DFM}

procedure TMainform.btSavImgClick(Sender: TObject);
begin
  if SavePictureDialog1.Execute
    then imAnzeige.picture.bitmap.SaveToFile(SavePictureDialog1.Filename);
end;

procedure TMainform.btImgOpnClick(Sender: TObject);
var
  FileHeader:TBitmapfileheader;
  InfoHeader:TBitmapinfoheader;
  s         :TFilestream;
begin
  if OpenPictureDialog1.Execute
    then begin
      //Bitmap Header auslesen um Mindestfarbtiefe vorrauszusetzen
      try
        s:=TFileStream.Create(OpenPictureDialog1.Filename,fmOpenRead);
        s.Read(FileHeader,SizeOf(FileHeader));
        s.Read(InfoHeader,SizeOf(InfoHeader));
      finally
        s.Free;
      end;

      //Bei zu kleiner Farbtiefe Fehler ausgeben
      if InfoHeader.biBitCount<24
      then begin
          MessageDlg('Das geladene Bitmap hat eine zu geringe Farbdichte, um '
                     +'Informationen in ihm zu speichern. Benutzen Sie ein '
                     +'Bitmap mit mindestens 16 Bit Farbtiefe pro Pixel!',
                     mtError,[mbOK],0);
          imAnzeige.picture.Bitmap:=nil;
      end
      //Bei ausreichender Farbtiefe (mindestens 24 Bit) Bild ffnen
      else
        imAnzeige.picture.Bitmap.LoadFromFile(OpenPictureDialog1.Filename);

      //Image Gre ndern (wegen Scrollbox)
      imAnzeige.Width:=imAnzeige.picture.Bitmap.Width;
      imAnzeige.Height:=imAnzeige.picture.Bitmap.Height;

      //Statusanzeige
      lblPixel.Caption:=IntToStr(imAnzeige.Width*imAnzeige.Height);
      Verfuegbar;
    end;
end;

procedure TMainform.btOpnTxtClick(Sender: TObject);
begin
  if OpenDialog1.Execute
    then meText.Lines.LoadFromFile(OpenDialog1.Filename);
end;

procedure TMainform.btSavTxtClick(Sender: TObject);
begin
  if SaveDialog1.Execute
    then meText.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TMainform.btImgTxtClick(Sender: TObject);
begin
  Enable(False);
  meText.Text:=XOrCode(Decodiere(imAnzeige.picture.bitmap));
  Enable(True);
end;

procedure TMainform.btTxtImgClick(Sender: TObject);
begin
  Enable(False);
  //bei Gre von 0 wird nicht neu gezeichnet, whrend gerechnet wird
  imAnzeige.Width:=0;
  imAnzeige.Height:=0;
  //Codieren, wenn der Text ins Bild passt
  if Length(meText.Text)*3<(imAnzeige.Picture.Bitmap.Height*imAnzeige.Picture.Bitmap.Width)
    then Codiere(imAnzeige.Picture.Bitmap, XOrCode(meText.Text));
  //Gre 0 aufheben
  imAnzeige.Width:=imAnzeige.Picture.Bitmap.Width;
  imAnzeige.Height:=imAnzeige.Picture.Bitmap.Height;
  Enable(True);
end;

procedure TMainform.meTextChange(Sender: TObject);
begin
  //Statusanzeige
  lblText.Caption:=IntToStr(Length(meText.Text));
  Verfuegbar;
end;

//Berechnet verfgbare Textzeichen und gibt Anzahl aus
Procedure TMainform.Verfuegbar;
begin
  if StrToInt(lblText.Caption)*3<StrToInt(lblPixel.Caption)
    then lblVerfuegbar.Caption:=
      IntToStr((StrToInt(lblPixel.Caption)-StrToInt(lblText.Caption)*3)div 3)
    else lblVerfuegbar.Caption:='Der Text ist zur Zeit'
                                +#10+#13+'zum Codieren zu lang.'
                                +#10+#13+'ffnen Sie ein'
                                +#10+#13+'greres Bild';
end;

Procedure TMainform.Enable(Value: Boolean);
var
  i: Integer;
begin
  for i:=0 to ComponentCount-1
    do if Components[i] is TControl
      then TControl(Components[i]).Enabled:=Value;
end;

procedure TMainform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if assigned(Statusform) then
    Statusform.Abort:=True;
end;

procedure TMainform.Beenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainform.Info1Click(Sender: TObject);
var
  Infoform: TInfoform;
begin
  Application.CreateForm(TInfoForm, InfoForm);
  try
    Infoform.Showmodal;
  finally
    Infoform.Free;
  end;
end;

end.
